	;
	; regular 4x driver
	;
	org $1001-2
	dw $1001
	
	dw $100b,0
	db $9e,"4109",0,0,0
	
time	= $0C10
max_raster = $0C3F
max_raster_chars = $0C38

	jmp start
	;
	align 128
music_beg
	include "!playerv.asm"
	include "!player.asm"
	include "music.asm"
	include "!volmap.asm"
music_end
	;
	
Print16	macro addr
	lda #"$"
	jsr $FFD2
	lda #addr >> 8
	jsr $FB10
	lda #addr & 255
	jsr $FB10
	endm
	
start	jsr $FF4F
	db $93,$90
	db "ELAPSED TIME  : 00:00 ( )",$0D
	db "MAXIMUM RASTER: 00    ( )",$0D
	db $0D
	db $9E,"(PRESS CURSOR RIGHT TO FADE OUT)",$0D
	db $0D
	db $90,"MUSIC         : "
	;
	db 0                          
	;       
	Print16 music_beg    
	jsr $FF4F
	db " - ",0
	Print16 music_end
	;
	sei
	;STA $FF3F
	;
	lda #$00
	sta time+7
	sta max_raster
	;
	lda #$41
	sta $FF19
	lda #$51
	sta $FF15
	;                   
	;LDX #Channel1 & 255
	;LDY #Channel1 >> 8
	;JSR set_ch1
	;
	;LDX #Channel2 & 255
	;LDY #Channel2 >> 8
	;JSR set_ch2
	;
	jsr PLAYER_FREQ_INIT
	;
	; ---
	;        
	ldy #$00
	ldx #$00
delay	inx
	bne delay
	iny
	bne delay
	;
d1	lda $FF1D
	cmp #$F8
	bne d1
	;
d2	lda $FF1D
	cmp #$10
	bne d2
	;
	;JMP *
	;
x0	
	lda x1+1
	clc
	adc #$50
	bcc x2
	lda #$00
x2	sta x1+1
	;
x1	lda #$100-$50
	ldx #$00
sync0	inx
	cmp $FF1D
	bne sync0
	;
	ldx $FF1C
	cpx #$FE & 255
	bne sync0
	;
	dec $FF19
	lda $FF1D
	sta r_start+1
	;
	cmp #$00
	bne sound_only
	;
	jsr PLAYER
	;
vol_down
	lda #$00
	beq no_vol_down
	;
vol_delay
	lda #$00
	clc
	adc #$01
	and #$0F
	sta vol_delay+1
	bne no_vol_down
	;
	lda VOLUME
	clc
	adc #$09
	cmp #21*9
	bne do_vol_down
	jmp $FFF6
do_vol_down
	sta VOLUME
no_vol_down
	;
	jsr INC_TIMER
	;
	jmp x3
sound_only
	jsr PLAYER_SOUND
	;
x3	; ------------
	;
	lda $DA		; store cnt
	sec 
	sbc #$05
	tax
	;
	lda $C9,x
	sta $FF11
	lda $C6,x
	sta $FF0E
	lda $C7,x
	sta $FF0F
	lda $C8,x
	sta $FF10
	lda $FF12
	and #$FC
	ora $CA,x
	sta $FF12
	;
	inc $FF19
	lda $FF1D
	sec
r_start	sbc #$00
	cmp max_raster
	bcc not_larger
	;
	sta max_raster
	;
	and #$0F    
	tax
	lda hex_char,x
	sta max_raster_chars+1
	;
	lda max_raster
	lsr a
	lsr a
	lsr a
	lsr a
	tax
	lda hex_char,x
	sta max_raster_chars
	;
not_larger
	;
	;LDA $FF12
	;AND #$03
	;JSR $FB10
	;LDA $FF0E
	;JSR $FB10
	;LDA #$0D
	;JSR $FFD2
	;
kdelay	ldy #$00
	beq kcheck
	dey 
	jmp kend
	
kcheck	lda #$BF
	sta $FD30
	sta $FF08
	lda $FF08
	cmp #$F7
	bne x5
	;   
	lda #$21
	sta $FF15
	sta vol_down+1
	; do something on keypress
	;
x5	;
	ldy #$04    
kend	sty kdelay+1
	;
	jmp x0
	;
	
INC_TIMER
	lda time+7
	clc
	adc #$01
	cmp #50
	bne inc1     
	;
	ldx #$05
inc2	dex 
	cpx #$02
	beq inc2
	lda time,x
	clc
	adc #$01
	cmp time_end,x
	bne inc3
	lda #$30
inc3	sta time,x
	cmp #$30
	beq inc2
	;
	lda #$00
inc1	sta time+7
	;
	rts
time_end
	db $3A,$3A,$3A,$36,$3A
hex_char
	db "0123456789",1,2,3,4,5,6

